## liri-text-0.5.0-1.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

project("Text"
    VERSION "0.5.0"
    DESCRIPTION "Text editor"
    LANGUAGES CXX C
)

## Shared macros and functions:
if(TEXT_WITH_FLUID AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/fluid/CMakeLists.txt")
    set(LIRI_LOCAL_ECM TRUE)
    set(FLUID_WITH_DOCUMENTATION FALSE)
    set(FLUID_WITH_DEMO FALSE)
endif()
if(LIRI_LOCAL_ECM)
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/fluid/cmake/shared/modules")
else()
    find_package(LiriCMakeShared "1.0.0" REQUIRED NO_MODULE)
    list(APPEND CMAKE_MODULE_PATH "${LCS_MODULE_PATH}")
endif()

## Set minimum versions required.
set(QT_MIN_VERSION "5.10.0")

## Liri specific setup common for all modules:
include(LiriSetup)

## Features:
option(TEXT_WITH_FLUID "Build together with Fluid" OFF)
add_feature_info("Text::WithFluid" TEXT_WITH_FLUID "Build together with Fluid")

## Find Qt 5.
find_package(Qt5 "${QT_MIN_VERSION}"
    CONFIG REQUIRED
    COMPONENTS
        Core
        Gui
        Widgets
        Svg
        Qml
        Quick
        QuickControls2
        Sql
        LinguistTools
)

## Add subdirectories:
if(TEXT_WITH_FLUID)
    add_subdirectory(fluid)
endif()
add_subdirectory(data)
add_subdirectory(src)

=== data/CMakeLists.txt ===
if(UNIX AND NOT APPLE AND NOT ANDROID)
    file(GLOB png_icons "${CMAKE_CURRENT_SOURCE_DIR}/icons/hicolor/*/*/*.png")
    file(GLOB svg_icons "${CMAKE_CURRENT_SOURCE_DIR}/icons/hicolor/*/*/*.svg")
    foreach(source_path IN LISTS png_icons svg_icons)
        string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/icons/hicolor/" "" icon_basename "${source_path}")
        get_filename_component(icon_directory "${icon_basename}" DIRECTORY)
        string(REPLACE "${icon_directory}/" "" icon_filename "${icon_basename}")
        string(REGEX REPLACE "\.(png|svg)" "" icon_filename "${icon_filename}")
        set(dest_path "${INSTALL_DATADIR}/icons/hicolor/${icon_directory}/")
        install(FILES "${source_path}" DESTINATION "${dest_path}")
    endforeach()
endif()

file(GLOB language_specs "${CMAKE_CURRENT_SOURCE_DIR}/language-specs/*.lang")
if(WIN32)
    install(FILES ${language_specs} DESTINATION "language-specs")
elseif(APPLE)
    install(FILES ${language_specs} DESTINATION "Contents/Resources/data/language-specs")
else()
    install(FILES ${language_specs} DESTINATION "${INSTALL_DATADIR}/liri-text/language-specs")
endif()

=== src/CMakeLists.txt ===
# Translations
file(GLOB LiriText_TRANSLATIONS "${CMAKE_CURRENT_SOURCE_DIR}/translations/*_*.ts")
qt5_add_translation(LiriText_QM_FILES ${LiriText_TRANSLATIONS})
if(WIN32)
    set(_translations_destdir "${CMAKE_CURRENT_BINARY_DIR}/translations")
elseif(APPLE)
    set(_translations_destdir "${CMAKE_CURRENT_BINARY_DIR}/Contents/Resources/data/translations")
elseif(LINUX OR BSD)
    set(_translations_destdir "${INSTALL_DATADIR}/liri-text/translations")
endif()
if(DEFINED _translations_destdir)
    install(FILES ${LiriText_QM_FILES} DESTINATION "${_translations_destdir}")
endif()

set(LiriText_ICON "${CMAKE_CURRENT_SOURCE_DIR}/../data/icons/io.liri.Text.icns")
set_source_files_properties("${LiriText_ICON}" PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources"
)

set(LiriText_RC "${CMAKE_CURRENT_SOURCE_DIR}/../data/io.liri.Text.rc")

if(WIN32)
    set(LiriText_DEFINES -DRELATIVE_LANGUAGE_PATH="/language-specs/")
elseif(APPLE)
    set(LiriText_DEFINES -DRELATIVE_LANGUAGE_PATH="../Resources/data/language-specs/")
else()
    set(LiriText_DEFINES -DABSOLUTE_LANGUAGE_PATH="${CMAKE_INSTALL_PREFIX}/${INSTALL_DATADIR}/liri-text/language-specs/")
endif()

if(APPLE OR WIN32)
    set(LiriText_OUTPUT_NAME "LiriText")
else()
    set(LiriText_OUTPUT_NAME "liri-text")
endif()

liri_add_executable(LiriText
    OUTPUT_NAME
        "${LiriText_OUTPUT_NAME}"
    SOURCES
        documenthandler.cpp
        documenthandler.h
        highlightdata.cpp
        highlightdata.h
        historymanager.cpp
        historymanager.h
        languagecontextbase.cpp
        languagecontextbase.h
        languagecontextcontainer.cpp
        languagecontextcontainer.h
        languagecontext.cpp
        languagecontext.h
        languagecontextkeyword.cpp
        languagecontextkeyword.h
        languagecontextreference.cpp
        languagecontextreference.h
        languagecontextsimple.cpp
        languagecontextsimple.h
        languagecontextsubpattern.cpp
        languagecontextsubpattern.h
        languagedatabasemaintainer.cpp
        languagedatabasemaintainer.h
        languagedefaultstyles.cpp
        languagedefaultstyles.h
        languageloader.cpp
        languageloader.h
        languagemanager.cpp
        languagemanager.h
        languagemetadata.h
        lirisyntaxhighlighter.cpp
        lirisyntaxhighlighter.h
        main.cpp
        ${LiriText_ICON}
        ${LiriText_RC}
        ${LiriText_QM_FILES}
    RESOURCES
        text.qrc
    DEFINES
        #QT_NO_CAST_FROM_ASCII
        #QT_NO_FOREACH
        -DTEXT_VERSION="${PROJECT_VERSION}"
        -DUSER_LANGUAGE_PATH="/language-specs/"
        -DLANGUAGE_DB_VERSION=1
        ${LiriText_DEFINES}
    APPDATA
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/io.liri.Text.appdata.xml"
    DESKTOP
        "${CMAKE_CURRENT_SOURCE_DIR}/../data/io.liri.Text.desktop"
    LIBRARIES
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Qml
        Qt5::Quick
        Qt5::QuickControls2
        Qt5::Sql
    GUI
)
set_target_properties(LiriText PROPERTIES
    MACOSX_BUNDLE_GUI_IDENTIFIER "io.liri.Text"
    MACOSX_BUNDLE_ICON_FILE "io.liri.Text"
    MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}"
)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Riley Trautman <asonix.dev@gmail.com>
# Contributor: Michael Spencer <sonrisesoftware@gmail.com>

pkgname=liri-text
pkgver=0.5.0
pkgrel=1
pkgdesc='Material Design text editor'
arch=('x86_64')
url='https://github.com/lirios/text'
license=('GPL')
depends=('fluid')
makedepends=('liri-cmake-shared' 'qt5-tools')
source=("$pkgname-$pkgver.tar.gz::https://github.com/lirios/text/archive/v$pkgver.tar.gz")
sha512sums=('a4c374ce79b06fea312e407a9062217be1eec42851a7cdb1a5ea927d7164c33fd9310fcf750f70dc1637b5c8b9b2037327742b32f6c26c58c15bc89b482454d9')

prepare() {
  mkdir -p build
}

build() {
  cd build
  cmake -DCMAKE_INSTALL_PREFIX=/usr ../text-$pkgver
}

package() {
  cd build
  make DESTDIR="$pkgdir" install
}
